#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_SignInCFG.h"
std::auto_ptr<M_SignInCFG> M_SignInCFG::msSingleton(nullptr);

int M_SignInCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_SignInCFGData* M_SignInCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_SignInCFGData>& M_SignInCFG::GetMapData()
{
	return mMapData;
}

void M_SignInCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_SignInCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_SignInCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mSignType = element->IntAttribute("SignType");
		{
			const char* FrontDisplay = element->Attribute("FrontDisplay");
			std::vector<std::string> vecFrontDisplay;
			boost::split(vecFrontDisplay, FrontDisplay, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFrontDisplay.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFrontDisplay[i].c_str(), &temp))
				{
					data.mFrontDisplay.push_back(temp);
				}
			}
		}
		{
			const char* FixedReward = element->Attribute("FixedReward");
			std::vector<std::string> vecFixedReward;
			boost::split(vecFixedReward, FixedReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFixedReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFixedReward[i].c_str(), &temp))
				{
					data.mFixedReward.push_back(temp);
				}
			}
		}
		{
			const char* ProbabilityReward = element->Attribute("ProbabilityReward");
			std::vector<std::string> vecProbabilityReward;
			boost::split(vecProbabilityReward, ProbabilityReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecProbabilityReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecProbabilityReward[i].c_str(), &temp))
				{
					data.mProbabilityReward.push_back(temp);
				}
			}
		}
		{
			const char* FirstRward = element->Attribute("FirstRward");
			std::vector<std::string> vecFirstRward;
			boost::split(vecFirstRward, FirstRward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFirstRward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFirstRward[i].c_str(), &temp))
				{
					data.mFirstRward.push_back(temp);
				}
			}
		}
		data.mBonusDoubles = element->IntAttribute("BonusDoubles");
		data.mVipLevel = element->IntAttribute("VipLevel");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_SignInCFG Loaded. Load Data:%u", mMapData.size());
}

void M_SignInCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_SignInCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_SignInCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_SignInCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "SignType", data.mSignType);
		LuaCfgHelper::readVectorInt(L, "FrontDisplay", data.mFrontDisplay);
		LuaCfgHelper::readVectorInt(L, "FixedReward", data.mFixedReward);
		LuaCfgHelper::readVectorInt(L, "ProbabilityReward", data.mProbabilityReward);
		LuaCfgHelper::readVectorInt(L, "FirstRward", data.mFirstRward);
		LuaCfgHelper::readInt(L, "BonusDoubles", data.mBonusDoubles);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_SignInCFG Loaded. Load Data:%u", mMapData.size());
}

void M_SignInCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_SignInCFG* M_SignInCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_SignInCFG());
	}
	return msSingleton.get();
}

void M_SignInCFG::Release()
{
	msSingleton.reset(nullptr);
}
